#ifndef L_SETTINGS_H
#define L_SETTINGS_H

#include <Bitmap.h>
#include <File.h>
#include <Entry.h>
#include <String.h>
#include <stdlib.h>
#include <Node.h>
#include <fs_attr.h>

#include <NodeInfo.h>

#include <View.h> // to get type supports

class lSettings
{
public:
	lSettings(const char* file);
	void 	ChangeFile(const char* newFile);
	bool	CreateFile(const char* file="");
	bool 	FileExists();
	BBitmap* FileIcon(icon_size which = B_LARGE_ICON);
	inline const char*File(){return(CurFile);}
	
		
	void 	WriteBool	(const char*name, 	bool value,			bool encrypt=false);
	void 	WriteInt32	(const char*name, 	int32 value, 		bool encrypt=false);
	void 	WriteString	(const char*name, 	const char*value,	bool encrypt=false);
	void 	WriteRect	(const char*name, 	BRect value,		bool encrypt=false);
	void 	WritePoint	(const char*name, 	BPoint value,		bool encrypt=false);
	void	WriteRGB	(const char*name,	rgb_color value, 	bool encrypt=false);
	
	bool 			ReadBool	(const char*name, bool encrypted=false);
	int32 			ReadInt32	(const char*name, bool encrypted=false);
	const char* 	ReadString	(const char*name, bool encrypted=false);
	BRect 			ReadRect	(const char*name, bool encrypted=false);
	BPoint 			ReadPoint	(const char*name, bool encrypted=false);
	rgb_color		ReadRGB		(const char*name, bool encrypted=false);
	
	// Special functions
	void	WriteWindowFrame(BRect rect);
	BRect			ReadWindowFrame();


	// FUTURE SUPPORT:
//	WriteMessage(const char*name, BMessage* value); // doesn't need to be encrypted
//	BMessage * ReadMessage(const char*name);

private:
	BString Decrypt(BString decrypt_this);
	BString Encrypt(BString encrypt_this);
	BString r_attr(const char*name);
	
	const char* CurFile;
		BNode pref_file;
};


#endif
